/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest{}

// AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest struct for AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest
type AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest struct {
	Service *string                              `json:"service,omitempty"`
	Data    *GoogleMyBusinessStaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest instantiates a new AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest() *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest {
	this := AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest{}
	var service string = "google_my_business_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequestWithDefaults() *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest {
	this := AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest{}
	var service string = "google_my_business_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) GetData() GoogleMyBusinessStaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret GoogleMyBusinessStaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) GetDataOk() (*GoogleMyBusinessStaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given GoogleMyBusinessStaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) SetData(v GoogleMyBusinessStaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest struct {
	value *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) Get() *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) Set(val *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest(val *AppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) *NullableAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest {
	return &NullableAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleMyBusinessStaticGoogleMyBusinessStaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
